// EditBox.cpp : implementation file
//

#include "stdafx.h"
#include "EditBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// EditBox

EditBox::EditBox(const RECT& rect, const CString& inString,
				 CWnd* parentWindow, CFont* parentFont) 
: inProcess(TRUE), validData(FALSE)
{
	const int windowStyle = WS_CHILD | WS_VISIBLE | WS_BORDER | ES_AUTOHSCROLL;

	Create(windowStyle, rect, parentWindow, 0);
	SetFont(parentFont);	//use dialog font instead of system font
	ReplaceSel(inString);
	SetSel(0, -1);
	SetFocus();				//time to edit
}

EditBox::~EditBox() {}


// App and Class Wiz generated stuff
BEGIN_MESSAGE_MAP(EditBox, CEdit)
	//{{AFX_MSG_MAP(EditBox)
	ON_WM_KILLFOCUS()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// EditBox message handlers

/////////////////////////////////////////////////////////////////////
void EditBox::OnKillFocus(CWnd* pNewWnd) 

//Here's how the edit box is made "modal-like".  We don't permit
//focus to leave the edit box until either <Return> or <Esc> is
//pressed.  Pressing one of those keys sets inProcess false
//so that focus can leave in a dignified manner.
{
	if (inProcess)	//only <Enter> or <Esc> will turn inProcess FALSE
		SetFocus();
	else
		CEdit::OnKillFocus(pNewWnd);
}
/////////////////////////////////////////////////////////////////////


BOOL EditBox::PreTranslateMessage(MSG* pMsg) 

//Since dialog boxes commandeer the <Return> and <Esc> keys for their 
//own use, if you want a crack at them, you've got to get to them while
//they are still WM_KEYDOWN's and before they get translated.

{
	UINT a = pMsg->message;
	if (a != 280 && a != WM_MOUSEFIRST && a != WM_PAINT && a != WM_KEYUP)
		int j = 2;
	switch (pMsg->message)
	{
	case WM_KEYDOWN:
		switch (pMsg->wParam)		  //virtual key value	
		{
		case VK_RETURN:
			inProcess = FALSE;
			validData = TRUE;
			DestroyWindow();
			return TRUE;

		case VK_ESCAPE:
			inProcess = FALSE;
			validData = FALSE;
			DestroyWindow();	
			return TRUE;
		}
		break;

	case WM_DESTROY:
		inProcess = FALSE;
		break;
	}
	//Let base class handle keys that are of no importance
	return CEdit::PreTranslateMessage(pMsg);
}


void EditBox::PostNcDestroy() 
{
	CEdit::PostNcDestroy();
	delete this;
}

