// EditBox.h : header file
//

#ifndef EDITBOX_H
#define EDITBOX_H

/////////////////////////////////////////////////////////////////////////////
// EditBox window

class EditBox : public CEdit
{

// Construction and Destruction
public:
	EditBox(const RECT& initPos, const CString& inString,
		    CWnd* pParentWindow, CFont* pParentFont);

//Note:  Since EditBoxes depart this planet via a delete this,
//They MUST only be created on the heap.  Making the dtor private
//enforces this restriction.
private:
	~EditBox(); // Edit box only allowed in heap

public:
	BOOL TransferOK() {return validData;}

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(EditBox)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL

	// Generated message map functions
protected:
	//{{AFX_MSG(EditBox)
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

private:
	BOOL inProcess;
	BOOL validData;
};

#endif
