// File UWOBJLST.CPP Object List class
// Manages an array of pointers to objects.
//  Source code for article
//  "C++ Classes for MDI Management"
//  Copyright Stephen Welstead 1996

#include <iostream.h>
#include "uwobjlst.h"

// Note:  Since the object_list does not allocate the actual
//        items in the list (it merely keeps track of them),
//        it does not delete them upon termination, or when
//        delete_item is called.  It is the calling application's
//        responsibility to delete the actual list items.

object_list::object_list (int max_items) {
      if (!(the_list = new p_void[max_items +1])) {
	 cerr << "Memory allocation failed in "
	   "object_list constructor.";
	 return; }
      the_list[0] = 0;  // don't use first position
      max_count = max_items;
      item_count = 0; }
	 
 int object_list::add_item (void *item_addr) {
    if (item_count >= max_count) return 0;
    the_list[item_count + 1] = item_addr;
    item_count++;
    return item_count; }

 int object_list::insert_item (int index,void *item_addr) {
    if (item_count >= max_count) return 0;
    if (index > max_count) return 0;
    for (int i=item_count;i>=index;i--)
	the_list [i+1] = the_list[i];
    the_list[index] = item_addr;
    item_count++;
    return 1; }

  void *object_list::at (int index) {
    if (index <= 0) return 0;
    if (index > item_count) return 0;
    return the_list[index]; }

  int object_list::get_count () {
    return item_count; }

  void object_list::delete_item (int index) {
     if (index <= 0) return;
     if (index > item_count) return;
     for (int i=index;i<=item_count-1;i++)
	 the_list[i] = the_list[i+1];
     item_count--;
     return; }

  object_list::~object_list() {
     delete the_list; }

