// File uwwin.h  Header file for base window class
//  Source code for article
//  "C++ Classes for MDI Management"
//  Copyright Stephen Welstead 1996

#ifndef UWWIN_H
#define UWWIN_H

// For 32-bit applications, make
// sure the constant WIN_32 is
// defined (may be a project define)

// __FLAT__ Borland's 32-bit flag:
#ifdef __FLAT__
#define WIN_32
#endif

#define STRICT
#include <windows.h>

class twindow {
   public:
   WNDCLASS wndclass;
   HWND hwindow;
   LPCSTR the_title;
   twindow (HINSTANCE hInstance,
       LRESULT CALLBACK window_proc,int window_extra,
       LPCSTR menu_name,LPCSTR title_name,
       LPCSTR class_name,LPCSTR icon_name);
   virtual void register_window_class (void);
   virtual void set_global_ptr (void);
   virtual int respond_wm_create (HWND hwnd);
   virtual int respond_wm_command (WPARAM wParam,
       LPARAM lParam);
   virtual int respond_wm_paint (void);
   virtual int respond_wm_mdiactivate (HWND hwnd,
       WPARAM wParam,LPARAM lParam);
   virtual int respond_wm_size (LPARAM lParam);
   virtual int respond_wm_queryendsession (void);
   virtual int respond_wm_close (void);
   virtual int respond_wm_destroy (HWND hwnd);
   virtual LRESULT CALLBACK default_window_proc
      (HWND hwnd,UINT message,WPARAM wParam,
      LPARAM lParam);
   virtual LRESULT CALLBACK handle_message
      (HWND hwnd,UINT message,WPARAM wParam,
      LPARAM lParam); };
#endif